/* ***********************************************************
 * This file was automatically generated on 2020-11-02.      *
 *                                                           *
 * Visual Basic .NET Bindings Version 2.1.27                 *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

using System;

namespace Tinkerforge
{
	/// <summary>
	///  Measures temperature with thermocouples
	/// </summary>
	public class BrickletThermocouple : Device
	{
		/// <summary>
		///  Used to identify this device type in
		///  <see cref="Tinkerforge.IPConnection.EnumerateCallback"/>.
		/// </summary>
		public static int DEVICE_IDENTIFIER = 266;

		/// <summary>
		///  The display name of this device.
		/// </summary>
		public static string DEVICE_DISPLAY_NAME = "Thermocouple Bricklet";

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_TEMPERATURE = 1;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_TEMPERATURE_CALLBACK_PERIOD = 2;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_TEMPERATURE_CALLBACK_PERIOD = 3;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_TEMPERATURE_CALLBACK_THRESHOLD = 4;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_TEMPERATURE_CALLBACK_THRESHOLD = 5;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_DEBOUNCE_PERIOD = 6;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_DEBOUNCE_PERIOD = 7;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_CONFIGURATION = 10;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_CONFIGURATION = 11;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_ERROR_STATE = 12;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_IDENTITY = 255;

		private const int CALLBACK_TEMPERATURE = 8;

		private const int CALLBACK_TEMPERATURE_REACHED = 9;

		private const int CALLBACK_ERROR_STATE = 13;


		/// <summary>
		/// </summary>
		public const char THRESHOLD_OPTION_OFF = 'x';

		/// <summary>
		/// </summary>
		public const char THRESHOLD_OPTION_OUTSIDE = 'o';

		/// <summary>
		/// </summary>
		public const char THRESHOLD_OPTION_INSIDE = 'i';

		/// <summary>
		/// </summary>
		public const char THRESHOLD_OPTION_SMALLER = '<';

		/// <summary>
		/// </summary>
		public const char THRESHOLD_OPTION_GREATER = '>';

		/// <summary>
		/// </summary>
		public const byte AVERAGING_1 = 1;

		/// <summary>
		/// </summary>
		public const byte AVERAGING_2 = 2;

		/// <summary>
		/// </summary>
		public const byte AVERAGING_4 = 4;

		/// <summary>
		/// </summary>
		public const byte AVERAGING_8 = 8;

		/// <summary>
		/// </summary>
		public const byte AVERAGING_16 = 16;

		/// <summary>
		/// </summary>
		public const byte TYPE_B = 0;

		/// <summary>
		/// </summary>
		public const byte TYPE_E = 1;

		/// <summary>
		/// </summary>
		public const byte TYPE_J = 2;

		/// <summary>
		/// </summary>
		public const byte TYPE_K = 3;

		/// <summary>
		/// </summary>
		public const byte TYPE_N = 4;

		/// <summary>
		/// </summary>
		public const byte TYPE_R = 5;

		/// <summary>
		/// </summary>
		public const byte TYPE_S = 6;

		/// <summary>
		/// </summary>
		public const byte TYPE_T = 7;

		/// <summary>
		/// </summary>
		public const byte TYPE_G8 = 8;

		/// <summary>
		/// </summary>
		public const byte TYPE_G32 = 9;

		/// <summary>
		/// </summary>
		public const byte FILTER_OPTION_50HZ = 0;

		/// <summary>
		/// </summary>
		public const byte FILTER_OPTION_60HZ = 1;


		/// <summary>
		///  This callback is triggered periodically with the period that is set by
		///  <see cref="Tinkerforge.BrickletThermocouple.SetTemperatureCallbackPeriod"/>. The parameter is the
		///  temperature of the thermocouple.
		///  
		///  The <see cref="Tinkerforge.BrickletThermocouple.TemperatureCallback"/> callback is only triggered if the temperature has
		///  changed since the last triggering.
		/// </summary>
		public event TemperatureEventHandler TemperatureCallback;
		/// <summary>
		/// </summary>
		public delegate void TemperatureEventHandler(BrickletThermocouple sender, int temperature);

		/// <summary>
		/// </summary>
		public event TemperatureEventHandler Temperature // for backward compatibility
		{
			add { TemperatureCallback += value; }
			remove { TemperatureCallback -= value; }
		}

		/// <summary>
		///  This callback is triggered when the threshold as set by
		///  <see cref="Tinkerforge.BrickletThermocouple.SetTemperatureCallbackThreshold"/> is reached.
		///  The parameter is the temperature of the thermocouple.
		///  
		///  If the threshold keeps being reached, the callback is triggered periodically
		///  with the period as set by <see cref="Tinkerforge.BrickletThermocouple.SetDebouncePeriod"/>.
		/// </summary>
		public event TemperatureReachedEventHandler TemperatureReachedCallback;
		/// <summary>
		/// </summary>
		public delegate void TemperatureReachedEventHandler(BrickletThermocouple sender, int temperature);

		/// <summary>
		/// </summary>
		public event TemperatureReachedEventHandler TemperatureReached // for backward compatibility
		{
			add { TemperatureReachedCallback += value; }
			remove { TemperatureReachedCallback -= value; }
		}

		/// <summary>
		///  This Callback is triggered every time the error state changes
		///  (see <see cref="Tinkerforge.BrickletThermocouple.GetErrorState"/>).
		/// </summary>
		public event ErrorStateEventHandler ErrorStateCallback;
		/// <summary>
		/// </summary>
		public delegate void ErrorStateEventHandler(BrickletThermocouple sender, bool overUnder, bool openCircuit);

		/// <summary>
		/// </summary>
		public event ErrorStateEventHandler ErrorState // for backward compatibility
		{
			add { ErrorStateCallback += value; }
			remove { ErrorStateCallback -= value; }
		}

		/// <summary>
		///  Creates an object with the unique device ID <c>uid</c> and adds  it to
		///  the IPConnection <c>ipcon</c>.
		/// </summary>
		public BrickletThermocouple(string uid, IPConnection ipcon) : base(uid, ipcon, DEVICE_IDENTIFIER, DEVICE_DISPLAY_NAME)
		{
			apiVersion[0] = 2;
			apiVersion[1] = 0;
			apiVersion[2] = 0;

			callbackWrappers[CALLBACK_TEMPERATURE] = new CallbackWrapper(OnTemperatureCallback);
			callbackWrappers[CALLBACK_TEMPERATURE_REACHED] = new CallbackWrapper(OnTemperatureReachedCallback);
			callbackWrappers[CALLBACK_ERROR_STATE] = new CallbackWrapper(OnErrorStateCallback);


			responseExpected[FUNCTION_GET_TEMPERATURE] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_TEMPERATURE_CALLBACK_PERIOD] = ResponseExpectedFlag.TRUE;
			responseExpected[FUNCTION_GET_TEMPERATURE_CALLBACK_PERIOD] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_TEMPERATURE_CALLBACK_THRESHOLD] = ResponseExpectedFlag.TRUE;
			responseExpected[FUNCTION_GET_TEMPERATURE_CALLBACK_THRESHOLD] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_DEBOUNCE_PERIOD] = ResponseExpectedFlag.TRUE;
			responseExpected[FUNCTION_GET_DEBOUNCE_PERIOD] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_CONFIGURATION] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_CONFIGURATION] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_GET_ERROR_STATE] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_GET_IDENTITY] = ResponseExpectedFlag.ALWAYS_TRUE;

			ipcon.AddDevice(this);
		}

		/// <summary>
		///  Returns the temperature of the thermocouple.
		///  
		///  If you want to get the temperature periodically, it is recommended
		///  to use the <see cref="Tinkerforge.BrickletThermocouple.TemperatureCallback"/> callback and set the period with
		///  <see cref="Tinkerforge.BrickletThermocouple.SetTemperatureCallbackPeriod"/>.
		/// </summary>
		public int GetTemperature()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_TEMPERATURE);

			byte[] response = SendRequest(request, 12);

			return LEConverter.IntFrom(8, response);
		}

		/// <summary>
		///  Sets the period with which the <see cref="Tinkerforge.BrickletThermocouple.TemperatureCallback"/> callback is triggered
		///  periodically. A value of 0 turns the callback off.
		///  
		///  The <see cref="Tinkerforge.BrickletThermocouple.TemperatureCallback"/> callback is only triggered if the temperature has changed
		///  since the last triggering.
		/// </summary>
		public void SetTemperatureCallbackPeriod(long period)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(12, FUNCTION_SET_TEMPERATURE_CALLBACK_PERIOD);
			LEConverter.To((int)period, 8, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the period as set by <see cref="Tinkerforge.BrickletThermocouple.SetTemperatureCallbackPeriod"/>.
		/// </summary>
		public long GetTemperatureCallbackPeriod()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_TEMPERATURE_CALLBACK_PERIOD);

			byte[] response = SendRequest(request, 12);

			return LEConverter.UIntFrom(8, response);
		}

		/// <summary>
		///  Sets the thresholds for the <see cref="Tinkerforge.BrickletThermocouple.TemperatureReachedCallback"/> callback.
		///  
		///  The following options are possible:
		///  
		///  <code>
		///   "Option", "Description"
		///  
		///   "'x'",    "Callback is turned off"
		///   "'o'",    "Callback is triggered when the temperature is *outside* the min and max values"
		///   "'i'",    "Callback is triggered when the temperature is *inside* the min and max values"
		///   "'&lt;'",    "Callback is triggered when the temperature is smaller than the min value (max is ignored)"
		///   "'&gt;'",    "Callback is triggered when the temperature is greater than the min value (max is ignored)"
		///  </code>
		/// </summary>
		public void SetTemperatureCallbackThreshold(char option, int min, int max)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(17, FUNCTION_SET_TEMPERATURE_CALLBACK_THRESHOLD);
			LEConverter.To((char)option, 8, request);
			LEConverter.To((int)min, 9, request);
			LEConverter.To((int)max, 13, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the threshold as set by <see cref="Tinkerforge.BrickletThermocouple.SetTemperatureCallbackThreshold"/>.
		/// </summary>
		public void GetTemperatureCallbackThreshold(out char option, out int min, out int max)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_TEMPERATURE_CALLBACK_THRESHOLD);

			byte[] response = SendRequest(request, 17);

			option = LEConverter.CharFrom(8, response);
			min = LEConverter.IntFrom(9, response);
			max = LEConverter.IntFrom(13, response);
		}

		/// <summary>
		///  Sets the period with which the threshold callback
		///  
		///  * <see cref="Tinkerforge.BrickletThermocouple.TemperatureReachedCallback"/>
		///  
		///  is triggered, if the threshold
		///  
		///  * <see cref="Tinkerforge.BrickletThermocouple.SetTemperatureCallbackThreshold"/>
		///  
		///  keeps being reached.
		/// </summary>
		public void SetDebouncePeriod(long debounce)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(12, FUNCTION_SET_DEBOUNCE_PERIOD);
			LEConverter.To((int)debounce, 8, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the debounce period as set by <see cref="Tinkerforge.BrickletThermocouple.SetDebouncePeriod"/>.
		/// </summary>
		public long GetDebouncePeriod()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_DEBOUNCE_PERIOD);

			byte[] response = SendRequest(request, 12);

			return LEConverter.UIntFrom(8, response);
		}

		/// <summary>
		///  You can configure averaging size, thermocouple type and frequency
		///  filtering.
		///  
		///  Available averaging sizes are 1, 2, 4, 8 and 16 samples.
		///  
		///  As thermocouple type you can use B, E, J, K, N, R, S and T. If you have a
		///  different thermocouple or a custom thermocouple you can also use
		///  G8 and G32. With these types the returned value will not be in °C/100,
		///  it will be calculated by the following formulas:
		///  
		///  * G8: ``value = 8 * 1.6 * 2^17 * Vin``
		///  * G32: ``value = 32 * 1.6 * 2^17 * Vin``
		///  
		///  where Vin is the thermocouple input voltage.
		///  
		///  The frequency filter can be either configured to 50Hz or to 60Hz. You should
		///  configure it according to your utility frequency.
		///  
		///  The conversion time depends on the averaging and filter configuration, it can
		///  be calculated as follows:
		///  
		///  * 60Hz: ``time = 82 + (samples - 1) * 16.67``
		///  * 50Hz: ``time = 98 + (samples - 1) * 20``
		/// </summary>
		public void SetConfiguration(byte averaging, byte thermocoupleType, byte filter)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(11, FUNCTION_SET_CONFIGURATION);
			LEConverter.To((byte)averaging, 8, request);
			LEConverter.To((byte)thermocoupleType, 9, request);
			LEConverter.To((byte)filter, 10, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the configuration as set by <see cref="Tinkerforge.BrickletThermocouple.SetConfiguration"/>.
		/// </summary>
		public void GetConfiguration(out byte averaging, out byte thermocoupleType, out byte filter)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_CONFIGURATION);

			byte[] response = SendRequest(request, 11);

			averaging = LEConverter.ByteFrom(8, response);
			thermocoupleType = LEConverter.ByteFrom(9, response);
			filter = LEConverter.ByteFrom(10, response);
		}

		/// <summary>
		///  Returns the current error state. There are two possible errors:
		///  
		///  * Over/Under Voltage and
		///  * Open Circuit.
		///  
		///  Over/Under Voltage happens for voltages below 0V or above 3.3V. In this case
		///  it is very likely that your thermocouple is defective. An Open Circuit error
		///  indicates that there is no thermocouple connected.
		///  
		///  You can use the <see cref="Tinkerforge.BrickletThermocouple.ErrorStateCallback"/> callback to automatically get triggered
		///  when the error state changes.
		/// </summary>
		public void GetErrorState(out bool overUnder, out bool openCircuit)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_ERROR_STATE);

			byte[] response = SendRequest(request, 10);

			overUnder = LEConverter.BoolFrom(8, response);
			openCircuit = LEConverter.BoolFrom(9, response);
		}

		/// <summary>
		///  Returns the UID, the UID where the Bricklet is connected to,
		///  the position, the hardware and firmware version as well as the
		///  device identifier.
		///  
		///  The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
		///  A Bricklet connected to an :ref:`Isolator Bricklet &lt;isolator_bricklet&gt;` is always at
		///  position 'z'.
		///  
		///  The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
		///  |device_identifier_constant|
		/// </summary>
		public override void GetIdentity(out string uid, out string connectedUid, out char position, out byte[] hardwareVersion, out byte[] firmwareVersion, out int deviceIdentifier)
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_GET_IDENTITY);

			byte[] response = SendRequest(request, 33);

			uid = LEConverter.StringFrom(8, response, 8);
			connectedUid = LEConverter.StringFrom(16, response, 8);
			position = LEConverter.CharFrom(24, response);
			hardwareVersion = LEConverter.ByteArrayFrom(25, response, 3);
			firmwareVersion = LEConverter.ByteArrayFrom(28, response, 3);
			deviceIdentifier = LEConverter.UShortFrom(31, response);
		}

		/// <summary>
		/// </summary>
		protected void OnTemperatureCallback(byte[] response)
		{
			if (response.Length != 12)
			{
				return; // silently ignoring callback with wrong length
			}

			int temperature = LEConverter.IntFrom(8, response);
			var handler = TemperatureCallback;

			if (handler != null)
			{
				handler(this, temperature);
			}
		}

		/// <summary>
		/// </summary>
		protected void OnTemperatureReachedCallback(byte[] response)
		{
			if (response.Length != 12)
			{
				return; // silently ignoring callback with wrong length
			}

			int temperature = LEConverter.IntFrom(8, response);
			var handler = TemperatureReachedCallback;

			if (handler != null)
			{
				handler(this, temperature);
			}
		}

		/// <summary>
		/// </summary>
		protected void OnErrorStateCallback(byte[] response)
		{
			if (response.Length != 10)
			{
				return; // silently ignoring callback with wrong length
			}

			bool overUnder = LEConverter.BoolFrom(8, response);
			bool openCircuit = LEConverter.BoolFrom(9, response);
			var handler = ErrorStateCallback;

			if (handler != null)
			{
				handler(this, overUnder, openCircuit);
			}
		}
	}
}
